unit Unit1;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QTypes, QMenus, StrUtils, QComCtrls, QImgList, Unit4,
  IdGlobal, Qt;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Button4: TButton;
    File1: TMenuItem;
    BackUp1: TMenuItem;
    ShowFile1: TMenuItem;
    UnitFiles1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Else1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    N2: TMenuItem;
    Setting1: TMenuItem;
    Frame41: TFrame4;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Setting1Click(Sender: TObject);
    procedure Frame41TreeView1DblClick(Sender: TObject);
    procedure Frame41TreeView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    MultiExt: array of string;
    procedure SearchFileName(const Str: string);
    procedure CopyFiles;
    procedure InitializeExt(const Exts: array of string);
    procedure ModeExecute(AMode: integer);
    { Private 錾 }
  public
    Mode: integer;
    DirPath: string;
    FileName: string;
    procedure Execute;
    { Public 錾 }
  end;

const
  UnitExt = '.pas';

  Flag = 'begin';

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.xfm}

{ TForm1 }

procedure TForm1.CopyFiles;
var
  i: integer;
  s, t: string;
  procedure SubName;
  begin
        t:=ExtractFileName(ListBox1.Items[i]);
    while ListBox1.Items.IndexOf(t) > i do
    begin
        Insert('~',t,LastDelimiter('.',t));
    end;
  end;
begin
        t:=ExtractFileName(ExtractFileDir(FileName));
        s:=IncludeTrailingPathDelimiter(DirPath)+t+'_'+                 
                ChangeFileExt(ExtractFileName(FileName),'');
  if Mode = 1 then
  begin
        s:=s+'_backup';
  end else
  begin
        s:=s+'_Units';
  end;
  if (Mode > 0)and(DirectoryExists(s) = false) then
  begin
        MkDir(s);
    if ExtractFileDir(Frame41.NodePathName) = ExcludeTrailingPathDelimiter(DirPath) then
    begin
        Frame41.TreeView1.Items.Add(Frame41.TreeView1.Selected,IncludeTrailingPathDelimiter(
                ExtractFileName(s))).ImageIndex:=0;
    end;
  end;
        s:=IncludeTrailingPathDelimiter(s);
  if Mode = 0 then
  begin
    for i:=0 to ListBox1.Items.Count-1 do
    begin
        SubName;
        ListBox1.Items[i]:=t;
    end;
  end else
  begin
    for i:=ListBox1.Items.Count-1 downto 0 do
    begin
        SubName;
      if FileExists(s+t) = true then
      begin
                DeleteFile(s+t);
      end;
      if CopyFileTo(ListBox1.Items[i],s+t) = true then
      begin
                ListBox1.Items[i]:=t;
      end else
      begin
                ListBox1.Items.Delete(i);
                Label2.Show;
      end;
    end;
  end;
end;

procedure TForm1.Execute;
var
  i: integer;
  s: string;
  Temp: TStringList;
begin
        Label2.Hide;
  if FileExists(FileName) = false then
  begin
        Exit;
  end;
        Temp:=TStringList.Create;
  try
        Temp.LoadFromFile(FileName);
        ChDir(ExtractFileDir(FileName));
        ListBox1.Clear;
    if Mode < 2 then
    begin
        ListBox1.Items.Add(FileName);
        s:=ChangeFileExt(FileName,Resource);
      if FileExists(s) = true then
      begin
                ListBox1.Items.Add(s);
      end;
    end;
    for i:=0 to Temp.Count-1 do
    begin
        s:=Temp[i];
      if AnsiContainsText(s,Flag) = true then
      begin
                break;
      end;
        SearchFileName(s);
    end;
    if (OKBottomDlg.RadioButton2.Checked = true)and(DirectoryExists(OKBottomDlg.Edit2.Text)) then
    begin
        ChDir(OKBottomDlg.Edit2.Text);
    end;
        CopyFiles;
  finally
        Temp.Free;
  end;
end;

procedure TForm1.SearchFileName(const Str: string);
var
  i, j, c: integer;
  s: string;
  procedure Detaile;
  var
    k: integer;
  begin
    if (AnsiCompareText(ExtractFileExt(s),UnitExt) = 0)and(FileExists(s) = true) then
    begin
        s:=ExpandUNCFileName(s);
        ListBox1.Items.Add(s);
      if Mode < 2 then
      begin
        for k:=0 to High(MultiExt) do
        begin
                s:=ChangeFileExt(s,MultiExt[k]);
          if FileExists(s) = true then
          begin
                ListBox1.Items.Add(s);
          end;
        end;
      end;
    end;
  end;
begin
        i:=1;
        j:=1;
        c:=0;
  while i <= Length(Str) do
  begin
    case c of
    0:
      case Str[i] of
      '''':
                c:=5;
      '{':
                c:=4;
      'i','I':
        if AnsiCompareText(Copy(Str,i-1,4),' in ') = 0 then
        begin
                c:=1;
        end;
      ',':
      begin
                s:=TrimLeft(Trim(Copy(Str,j,i-1)))+'.pas';
                Detaile;
                j:=i+1;
      end;
      end;
    1:
      if Str[i] = '''' then
      begin
                c:=2;
                j:=i+1;
      end;
    2:
      if (i = Length(Str))or(Str[i] = '''') then
      begin
        if (i+1 <= Length(Str))and(Str[i+1] = '''') then
        begin
                inc(i);
        end else
        begin
          if i = Length(Str) then
          begin
                s:=Copy(Str,j,i-j+1);
          end else
          begin
                s:=Copy(Str,j,i-j);
          end;
                Detaile;
                c:=3;
        end;
      end;
    3:
      if Str[i] = ',' then
      begin
                c:=0;
      end;
    4:
      if Str[i] = '}' then
      begin
                c:=0;
      end;
    5:
      if Str[i] = '''' then
      begin
                c:=0;
      end;
    end;
        inc(i);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
        Mode:=1;
//        Frame41.InitializeDir;
        Frame41.DirectoryListBox:=false;
        InitializeExt(['.dfm','.xfm']);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
        ModeExecute(1);
end;

procedure TForm1.ModeExecute(AMode: integer);
begin
  if Mode <> AMode then
  begin
        Mode:=AMode;
  end;
        FileName:=Frame41.NodePathName;
  if (OKBottomDlg.RadioButton4.Checked = true)and(DirectoryExists(OKBottomDlg.Edit2.Text) = true) then
  begin
        DirPath:=OKBottomDlg.Edit2.Text;
  end else
  begin
        DirPath:=ExtractFileDir(FileName);
  end;
        Execute;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
        ModeExecute(0);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
        ModeExecute(2);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
        Close;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
        Finalize(MultiExt);
        Frame41.TreeView1.Items.Clear;
end;

procedure TForm1.InitializeExt(const Exts: array of string);
var
  i: integer;
begin
        SetLength(MultiExt,Length(Exts));
  for i:=0 to High(Exts) do
  begin
        MultiExt[i]:=Exts[i];
  end;
end;

procedure TForm1.Setting1Click(Sender: TObject);
begin
        OKBottomDlg.ShowModal;
end;

procedure TForm1.Frame41TreeView1DblClick(Sender: TObject);
begin
        Frame41.TreeView1DblClick(Sender);
  if Frame41.TreeView1.Selected.ImageIndex > 0 then
  begin
        FileName:=Frame41.NodePathName;
        DirPath:=ExtractFileDir(FileName);
        Execute;
  end;
end;

procedure TForm1.Frame41TreeView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Frame41.TreeView1.Selected.ImageIndex = 0 then
  begin
        Frame41.TreeView1KeyDown(Sender, Key, Shift);
  end else
        if Key = Key_Return then
  begin
        ModeExecute(Mode);
  end;
end;

end.
