unit Unit4;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs, Qt,
  QComCtrls, QImgList;

type
  TFrame4 = class(TFrame)
    TreeView1: TTreeView;
    ImageList1: TImageList;
    procedure TreeView1DblClick(Sender: TObject);
    procedure TreeView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
  public
    DirectoryListBox: Boolean;
    function NodePathName: string;
    procedure InitializeDir;
    procedure GetDirectories;
    { Public 錾 }
  end;

const
  MasterExt = '.dpr';
  Resource = '.res';

implementation

{$R *.xfm}

procedure TFrame4.TreeView1DblClick(Sender: TObject);
var
  Temp: TTreeNode;
begin
  if TreeView1.Selected.ImageIndex = 0 then
  begin
        TreeView1.Selected.DeleteChildren;
        Temp:=TreeView1.Selected.getNextSibling;
    while Temp <> nil do
    begin
        Temp.Delete;
        Temp:=TreeView1.Selected.getNextSibling;
    end;
        Temp:=TreeView1.Selected.getPrevSibling;
    while Temp <> nil do
    begin
        Temp.Delete;
        Temp:=TreeView1.Selected.getPrevSibling;
    end;
        GetDirectories;
  end;
end;

procedure TFrame4.TreeView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = Key_Return then
  begin
        TreeView1DblClick(Sender);
  end;
end;

procedure TFrame4.GetDirectories;
var
  s: TSearchRec;
  t: string;
  i: integer;
begin
        t:=NodePathName;
        i:=FindFirst(IncludeTrailingPathDelimiter(t)+'*',faDirectory,s);
  while i = 0 do
  begin
        ChDir(t);
    if (s.Attr = faDirectory)and(Length(t)+1 < Length(ExpandUNCFileName(s.Name))) then
    begin
      with TreeView1.Items.AddChild(TreeView1.Selected,s.Name) do
      begin
                ImageIndex:=0;
                Text:=IncludeTrailingPathDelimiter(s.Name);
      end;
    end else
        if (DirectoryListBox = false)and(AnsiCompareText(ExtractFileExt(s.Name),MasterExt) = 0) then
    begin
        TreeView1.Items.AddChild(TreeView1.Selected,s.Name).ImageIndex:=1;
    end;
        i:=FindNext(s);
  end;
        FindClose(s);
        TreeView1.Selected.Expanded:=true;
end;

procedure TFrame4.InitializeDir;
var
  s: string;
  i, j: integer;
  Temp: TTreeNode;
  x: Boolean;
begin
        Temp:=nil;
        s:=IncludeTrailingPathDelimiter(GetCurrentDir);
        x:=false;
        j:=1;
        TreeView1.Items.Clear;
  for i:=1 to Length(s) do
  begin
    if (IsPathDelimiter(s,i) = true)and(IsPathDelimiter(s,i+1) = false) then
    begin
      if x = false then
      begin
                Temp:=TreeView1.Items.Add(Temp,Copy(s,j,i-j+1));
                Temp.ImageIndex:=0;
                x:=true;
      end else
      begin
                Temp:=TreeView1.Items.AddChild(Temp,Copy(s,j,i-j+1));
                Temp.ImageIndex:=0;
      end;
        j:=i+1;
    end;
  end;
        Temp.Selected:=true;
        GetDirectories;
end;

function TFrame4.NodePathName: string;
var
  Temp: TTreeNode;
begin
        Temp:=TreeView1.Selected;
        result:=Temp.Text;
  while Temp.Level > 0 do
  begin
        Temp:=Temp.Parent;
        Insert(Temp.Text,result,1);
  end;
end;

end.
